'use client';
var jsxRuntime = require('react/jsx-runtime');
var MuiButton = require('@mui/material/Button');
var CircularProgress = require('@mui/material/CircularProgress');
var React = require('react');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var MuiButton__default = /*#__PURE__*/_interopDefault(MuiButton);
var CircularProgress__default = /*#__PURE__*/_interopDefault(CircularProgress);

/**
 * 合併 SxProps 物件陣列，並過濾掉 false 和 undefined 的值。
 *
 * @param styles 要合併的 SxProps 物件陣列
 */ const mergeSx = (...styles)=>styles.reduce((acc, sx)=>{
        if (!sx) return acc;
        if (Array.isArray(sx)) {
            return [
                ...acc,
                ...sx
            ];
        }
        return [
            ...acc,
            sx
        ];
    }, []);
const serverOnlySx = ()=>({
        position: 'absolute',
        width: 1,
        height: 1,
        padding: 0,
        overflow: 'hidden',
        clip: 'rect(0, 0, 0, 0)',
        whiteSpace: 'nowrap',
        border: 0
    });

/**
 * 表示一個可點擊的按鈕元件，用於觸發相關的業務邏輯。
 *
 * 參考 [Material-UI Button](https://mui.com/material-ui/react-button/)
 *
 * @example
 *
 *  ```tsx
 * <Button variant="contained">Contained</Button>
 * <Button variant="outlined">Outlined</Button>
 * <Button variant="text">Text</Button>
 * ```
 */ const Button = /*#__PURE__*/ React.forwardRef((props, ref)=>{
    const { children, sx, loading = false, disabled = false, shape = 'default', variant = 'contained', ...rest } = props;
    return /*#__PURE__*/ jsxRuntime.jsxs(MuiButton__default.default, {
        ref: ref,
        sx: mergeSx({
            '&.MuiButton-text:hover': {
                backgroundColor: 'inherit'
            },
            '&.Mui-disabled': {
                pointerEvents: 'inherit',
                cursor: 'not-allowed'
            }
        }, shape === 'round' && {
            borderRadius: '40px',
            paddingInlineStart: '20px',
            paddingInlineEnd: '20px'
        }, sx),
        variant: variant,
        disabled: loading || disabled,
        ...rest,
        children: [
            children,
            loading && /*#__PURE__*/ jsxRuntime.jsx(CircularProgress__default.default, {
                sx: {
                    ml: 1
                },
                color: "inherit",
                size: "1.5em"
            })
        ]
    });
});

exports.Button = Button;
exports.mergeSx = mergeSx;
exports.serverOnlySx = serverOnlySx;
