'use client';
var jsxRuntime = require('react/jsx-runtime');
var material = require('@mui/material');
var useEmblaCarousel = require('embla-carousel-react');
var React = require('react');
var Button12s = require('./Button-12s-DAXoQHAS.js');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var useEmblaCarousel__default = /*#__PURE__*/_interopDefault(useEmblaCarousel);

const CarouselContext = /*#__PURE__*/ React.createContext(null);
const useCarousel = ()=>{
    const context = React.useContext(CarouselContext);
    if (!context) {
        throw new Error('useCarousel must be used within a <Carousel />');
    }
    return context;
};
/**
 * 一個基於 Embla Carousel 的 Carousel 元件，通常用於展示多個元素，並提供左右滑動的功能。
 *
 * 參考 [Embla Carousel](https://www.embla-carousel.com/)
 *
 * @example
 *
 * ```tsx
 * <Carousel>
 *  <CarouselContent>
 *   {Array.from({ length: 5 }).map((_, index) => (
 *    <CarouselItem key={index}>
 *      {index + 1}
 *    </CarouselItem>
 *   ))}
 *  </CarouselContent>
 *  <CarouselPrevious />
 *  <CarouselNext />
 * </Carousel>
 * ```
 */ const Carousel = ({ orientation = 'horizontal', opts, setApi, plugins, className, children, sx, ...props })=>{
    const [carouselRef, api] = useEmblaCarousel__default.default({
        ...opts,
        axis: orientation === 'horizontal' ? 'x' : 'y'
    }, plugins);
    const [canScrollPrev, setCanScrollPrev] = React.useState(false);
    const [canScrollNext, setCanScrollNext] = React.useState(false);
    const onSelect = React.useCallback((_api)=>{
        if (!_api) return;
        setCanScrollPrev(_api.canScrollPrev());
        setCanScrollNext(_api.canScrollNext());
    }, []);
    const scrollPrev = React.useCallback(()=>{
        api?.scrollPrev();
    }, [
        api
    ]);
    const scrollNext = React.useCallback(()=>{
        api?.scrollNext();
    }, [
        api
    ]);
    const handleKeyDown = React.useCallback((event)=>{
        if (event.key === 'ArrowLeft') {
            event.preventDefault();
            scrollPrev();
        } else if (event.key === 'ArrowRight') {
            event.preventDefault();
            scrollNext();
        }
    }, [
        scrollPrev,
        scrollNext
    ]);
    React.useEffect(()=>{
        if (!api || !setApi) return;
        setApi(api);
    }, [
        api,
        setApi
    ]);
    React.useEffect(()=>{
        if (!api) return undefined;
        onSelect(api);
        api.on('reInit', onSelect);
        api.on('select', onSelect);
        return ()=>{
            api?.off('select', onSelect);
        };
    }, [
        api,
        onSelect
    ]);
    const contextValue = React.useMemo(()=>({
            carouselRef,
            api,
            opts,
            orientation: orientation || (opts?.axis === 'y' ? 'vertical' : 'horizontal'),
            scrollPrev,
            scrollNext,
            canScrollPrev,
            canScrollNext
        }), [
        api,
        canScrollNext,
        canScrollPrev,
        carouselRef,
        opts,
        orientation,
        scrollNext,
        scrollPrev
    ]);
    return /*#__PURE__*/ jsxRuntime.jsx(CarouselContext.Provider, {
        value: contextValue,
        children: /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
            onKeyDownCapture: handleKeyDown,
            sx: Button12s.mergeSx({
                position: 'relative'
            }, sx),
            role: "region",
            "aria-roledescription": "carousel",
            ...props,
            children: children
        })
    });
};

exports.Carousel = Carousel;
exports.useCarousel = useCarousel;
