'use client';
var jsxRuntime = require('react/jsx-runtime');
require('@mui/material/Button');
require('@mui/material/CircularProgress');
var React = require('react');
require('@mui/material/IconButton');
var iconsMaterial = require('@mui/icons-material');
var material = require('@mui/material');
var Button12s = require('./Button-12s-DAXoQHAS.js');
var IconButton12s = require('./IconButton-12s-CM4Y4zw4.js');
var DecorativeTitle12s = require('./DecorativeTitle-12s-c-DSAXac.js');
var Card12s = require('./Card-12s-BIi-BPmJ.js');
require('@mui/material/Backdrop');

/**
 * `Drawer` 抽屜元件，由螢幕邊緣滑出的浮動面版，
 * 常見的應用是作為導航用途，例如 Navigation drawers。
 *
 * 參考 [Material-UI Button](https://mui.com/material-ui/react-drawer/)
 */ const Drawer = /*#__PURE__*/ React.forwardRef(({ title, loading = false, loadingOptions, showCloseIcon = true, headerProps = {}, disableBackdropClick = false, contentProps = {}, actionsProps = {}, onClose: onCloseOuter, onSubmit, submitText = 'Submit', cancelText = 'Cancel', customActions, anchor = 'right', children, ...rest }, ref)=>{
    const [isSubmitting, setIsSubmitting] = React.useState(false);
    const handleCloseInter = (event, reason)=>{
        if (reason === 'backdropClick' && disableBackdropClick || isSubmitting) {
            return;
        }
        onCloseOuter?.(event, reason);
    };
    const handleCloseButtonClick = (event)=>{
        if (!isSubmitting) {
            onCloseOuter?.(event, 'closeButtonClick');
        }
    };
    const handleSubmit = async ()=>{
        setIsSubmitting(true);
        try {
            await onSubmit?.();
        } finally{
            setIsSubmitting(false);
        }
    };
    return /*#__PURE__*/ jsxRuntime.jsxs(material.Drawer, {
        ref: ref,
        ...rest,
        anchor: anchor,
        onClose: handleCloseInter,
        PaperProps: {
            ...rest?.PaperProps,
            sx: Button12s.mergeSx({
                minWidth: {
                    xs: '100%',
                    md: '30%'
                }
            }, rest?.PaperProps?.sx)
        },
        children: [
            (title || showCloseIcon) && /*#__PURE__*/ jsxRuntime.jsxs(material.Box, {
                ...headerProps,
                sx: Button12s.mergeSx({
                    px: 3,
                    py: 2,
                    display: 'flex',
                    alignItems: 'center',
                    justifyContent: 'space-between'
                }, headerProps?.sx),
                children: [
                    /*#__PURE__*/ jsxRuntime.jsx(DecorativeTitle12s.DecorativeTitle, {
                        sx: {
                            flex: 1
                        },
                        loading: loading,
                        ...headerProps?.titleProps,
                        children: title
                    }),
                    showCloseIcon && /*#__PURE__*/ jsxRuntime.jsx(IconButton12s.IconButton, {
                        "aria-label": "drawer-close",
                        onClick: handleCloseButtonClick,
                        disabled: isSubmitting,
                        sx: {
                            color: 'text.secondary'
                        },
                        size: "small",
                        children: /*#__PURE__*/ jsxRuntime.jsx(iconsMaterial.Close, {})
                    })
                ]
            }),
            /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
                ...contentProps,
                sx: Button12s.mergeSx({
                    px: 3,
                    py: 2,
                    overflow: 'auto',
                    flexGrow: 1
                }, (contentProps?.dividers ?? true) && {
                    borderTop: 1,
                    borderBottom: 1,
                    borderColor: 'divider'
                }, contentProps?.sx),
                children: loading ? /*#__PURE__*/ jsxRuntime.jsx(Card12s.LoadingContent, {
                    ...loadingOptions
                }) : children
            }),
            (onSubmit || customActions) && /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
                ...actionsProps,
                sx: Button12s.mergeSx({
                    p: 1.5,
                    position: 'sticky',
                    bottom: 0,
                    display: 'flex',
                    alignItems: 'center',
                    justifyContent: 'center',
                    gap: 1.5
                }, actionsProps?.sx),
                children: customActions || /*#__PURE__*/ jsxRuntime.jsxs(jsxRuntime.Fragment, {
                    children: [
                        /*#__PURE__*/ jsxRuntime.jsx(Button12s.Button, {
                            variant: "outlined",
                            size: "medium",
                            onClick: handleCloseButtonClick,
                            disabled: isSubmitting,
                            children: cancelText
                        }),
                        /*#__PURE__*/ jsxRuntime.jsx(Button12s.Button, {
                            variant: "contained",
                            size: "medium",
                            onClick: handleSubmit,
                            loading: isSubmitting,
                            children: submitText
                        })
                    ]
                })
            })
        ]
    });
});
if (process.env.NODE_ENV !== 'production') {
    Drawer.displayName = 'GwDrawer';
}

exports.Drawer = Drawer;
