'use client';
var jsxRuntime = require('react/jsx-runtime');
var material = require('@mui/material');
var Button12s = require('./Button-12s-DAXoQHAS.js');

/**
 * 用於下拉式區域的 Popper。
 *
 * 參考 [Material-UI Popper](https://mui.com/material-ui/react-popper/)
 *
 * @example
 *
 * ```tsx
 * <Button ref={anchorRef} onClick={() => setOpen(true)}>
 *   Open
 * </Button>
 * <DropDown
 *  open={open}
 *  onClose={() => setOpen(false)}
 *  anchorRef={anchorRef}
 * >
 *  content
 * </DropDown>
 * ```
 */ const DropDown = ({ open, anchorRef, onClose, paperProps, children, ...props })=>{
    const handleClose = (event)=>{
        if (anchorRef?.current && anchorRef.current.contains(event.target)) {
            return;
        }
        onClose?.();
    };
    return /*#__PURE__*/ jsxRuntime.jsx(material.Popper, {
        placement: "bottom-end",
        ...props,
        open: open,
        anchorEl: anchorRef?.current,
        transition: true,
        children: ({ TransitionProps })=>/*#__PURE__*/ jsxRuntime.jsx(material.Fade, {
                ...TransitionProps,
                children: /*#__PURE__*/ jsxRuntime.jsx(material.Paper, {
                    elevation: 0,
                    ...paperProps,
                    sx: Button12s.mergeSx({
                        border: 1,
                        borderColor: 'divider',
                        borderRadius: 4
                    }, paperProps?.sx),
                    children: /*#__PURE__*/ jsxRuntime.jsx(material.ClickAwayListener, {
                        onClickAway: handleClose,
                        children: /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
                            children: children
                        })
                    })
                })
            })
    });
};

exports.DropDown = DropDown;
