'use client';
var jsxRuntime = require('react/jsx-runtime');
var Stack = require('@mui/material/Stack');
var React = require('react');
var ImageField12s = require('./ImageField-12s-zWenscC7.js');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var Stack__default = /*#__PURE__*/_interopDefault(Stack);

/**
 * `ImageArray` 將多個 `ImageField` 包裝成陣列，並提供新增、刪除功能。
 */ const ImageArray = ({ maxCount = 1, images: imagesOuter, defaultConfig, onAdd, onDelete })=>{
    const [images, setImages] = React.useState(imagesOuter ?? []);
    React.useEffect(()=>{
        setImages(imagesOuter ?? []);
    }, [
        imagesOuter
    ]);
    const handleAddImage = (_, newImage)=>{
        if (!newImage) {
            return;
        }
        const newImageInfo = {
            id: Date.now(),
            image: newImage,
            imageName: newImage.name
        };
        if (onAdd) {
            onAdd(newImageInfo, [
                ...images,
                newImageInfo
            ]);
            return;
        }
        setImages((prevImages)=>[
                ...prevImages,
                newImageInfo
            ]);
    };
    const handleDeleteImage = (id)=>{
        if (onDelete) {
            const deleteFile = images.find((image)=>image.id === id);
            if (!deleteFile) {
                return;
            }
            onDelete(id, deleteFile, images.filter((image)=>image.id !== id));
            return;
        }
        setImages((prevImages)=>prevImages.filter((image)=>image.id !== id));
    };
    return /*#__PURE__*/ jsxRuntime.jsxs(Stack__default.default, {
        direction: "row",
        alignItems: "center",
        gap: 1,
        flexWrap: "wrap",
        children: [
            images.map(({ id, ...imageRest })=>/*#__PURE__*/ jsxRuntime.jsx(ImageField12s.ImageField, {
                    ...defaultConfig,
                    ...imageRest,
                    onChange: (_, newImage)=>{
                        if (!newImage) {
                            handleDeleteImage(id);
                        }
                    }
                }, id)),
            maxCount > images.length && /*#__PURE__*/ jsxRuntime.jsx(ImageField12s.ImageField, {
                ...defaultConfig,
                onChange: handleAddImage
            })
        ]
    });
};

exports.ImageArray = ImageArray;
