'use client';
var jsxRuntime = require('react/jsx-runtime');
var iconsMaterial = require('@mui/icons-material');
var material = require('@mui/material');
var utils = require('@mui/material/utils');
var React = require('react');
var Button12s = require('./Button-12s-DAXoQHAS.js');
var IconButton12s = require('./IconButton-12s-CM4Y4zw4.js');
var DecorativeTitle12s = require('./DecorativeTitle-12s-c-DSAXac.js');
var Card12s = require('./Card-12s-BIi-BPmJ.js');
require('@mui/material/Backdrop');
require('@mui/material/CircularProgress');

/**
 * `Modal` 是一個封裝好的對話框元件，提供了標題、內容、確定、取消等功能。
 *
 * 參考 [Material-UI Dialog](https://mui.com/material-ui/react-dialog/)
 */ const Modal = /*#__PURE__*/ React.forwardRef(({ title, loading = false, loadingOptions, showCloseIcon = true, titleProps = {}, disableBackdropClick = false, contentProps = {}, actionsProps = {}, onClose: onCloseOuter, onSubmit, submitButtonText = 'Submit', cancelButtonText = 'Cancel', customActions, children, ...rest }, ref)=>{
    const [isSubmitting, setIsSubmitting] = React.useState(false);
    const handleCloseInter = (event, reason)=>{
        if (reason === 'backdropClick' && disableBackdropClick || isSubmitting) {
            return;
        }
        onCloseOuter?.(event, reason);
    };
    const handleCloseButtonClick = (event)=>{
        if (!isSubmitting) {
            onCloseOuter?.(event, 'closeButtonClick');
        }
    };
    const handleSubmit = async ()=>{
        setIsSubmitting(true);
        try {
            await onSubmit?.();
        } finally{
            setIsSubmitting(false);
        }
    };
    return /*#__PURE__*/ jsxRuntime.jsxs(material.Dialog, {
        ref: ref,
        ...rest,
        onClose: handleCloseInter,
        slotProps: {
            ...rest.slotProps,
            paper: utils.mergeSlotProps(rest.slotProps?.paper, {
                sx: {
                    borderRadius: 4
                }
            })
        },
        children: [
            (title || showCloseIcon) && /*#__PURE__*/ jsxRuntime.jsxs(material.DialogTitle, {
                color: "primary.main",
                ...titleProps,
                sx: Button12s.mergeSx({
                    display: 'flex',
                    justifyContent: 'space-between',
                    alignItems: 'center'
                }, titleProps?.sx),
                children: [
                    /*#__PURE__*/ jsxRuntime.jsx(DecorativeTitle12s.DecorativeTitle, {
                        sx: {
                            flex: 1
                        },
                        loading: loading,
                        children: title
                    }),
                    showCloseIcon && /*#__PURE__*/ jsxRuntime.jsx(IconButton12s.IconButton, {
                        "aria-label": "modal-close",
                        onClick: handleCloseButtonClick,
                        disabled: isSubmitting,
                        sx: {
                            color: 'text.secondary'
                        },
                        size: "small",
                        children: /*#__PURE__*/ jsxRuntime.jsx(iconsMaterial.Close, {})
                    })
                ]
            }),
            /*#__PURE__*/ jsxRuntime.jsx(material.DialogContent, {
                ...contentProps,
                dividers: contentProps?.dividers ?? true,
                children: loading ? /*#__PURE__*/ jsxRuntime.jsx(Card12s.LoadingContent, {
                    ...loadingOptions
                }) : children
            }),
            (onSubmit || customActions) && /*#__PURE__*/ jsxRuntime.jsx(material.DialogActions, {
                ...actionsProps,
                sx: Button12s.mergeSx({
                    paddingX: 3,
                    paddingY: 2
                }, actionsProps?.sx),
                children: customActions || /*#__PURE__*/ jsxRuntime.jsxs(jsxRuntime.Fragment, {
                    children: [
                        /*#__PURE__*/ jsxRuntime.jsx(Button12s.Button, {
                            variant: "outlined",
                            size: "medium",
                            onClick: handleCloseButtonClick,
                            loading: loading,
                            disabled: isSubmitting,
                            sx: {
                                minWidth: 80
                            },
                            children: cancelButtonText
                        }),
                        /*#__PURE__*/ jsxRuntime.jsx(Button12s.Button, {
                            variant: "contained",
                            size: "medium",
                            onClick: handleSubmit,
                            loading: loading || isSubmitting,
                            sx: {
                                minWidth: 80
                            },
                            children: submitButtonText
                        })
                    ]
                })
            })
        ]
    });
});
if (process.env.NODE_ENV !== 'production') {
    Modal.displayName = 'GwModal';
}

exports.Modal = Modal;
