'use client';
var jsxRuntime = require('react/jsx-runtime');
var material = require('@mui/material');
var SidebarContext12s = require('./SidebarContext-12s-F7oOZyM-.js');

const SwipeableDrawer = material.styled(material.SwipeableDrawer, {
    shouldForwardProp: (key)=>key !== 'width'
})(({ theme, width })=>({
        '& .MuiDrawer-paper': {
            maxHeight: '100svh',
            position: 'sticky',
            top: 0,
            width: `${width}px`,
            transition: theme.transitions.create('width', {
                easing: theme.transitions.easing.sharp,
                duration: theme.transitions.duration.enteringScreen
            })
        }
    }));
const SidebarMenuButton = ({ children, sx, tooltip, isActive, ...props })=>{
    const theme = material.useTheme();
    const { open } = SidebarContext12s.useSidebar();
    const button = /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        sx: {
            display: 'flex',
            alignItems: 'center',
            gap: theme.spacing(1),
            padding: theme.spacing(0.5),
            cursor: 'pointer',
            backgroundColor: isActive ? theme.palette.action.hover : 'transparent',
            borderRadius: theme.shape.borderRadius,
            '&:hover': {
                backgroundColor: theme.palette.action.hover
            },
            overflow: 'hidden',
            textOverflow: 'ellipsis',
            whiteSpace: 'nowrap',
            ...sx
        },
        ...props,
        children: children
    });
    if (!tooltip || open) return button;
    return /*#__PURE__*/ jsxRuntime.jsx(material.Tooltip, {
        title: tooltip,
        arrow: true,
        placement: "right",
        children: button
    });
};
const SidebarHeader = ({ sx, children, ...props })=>{
    const theme = material.useTheme();
    return /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        sx: {
            display: 'flex',
            alignItems: 'center',
            gap: theme.spacing(1),
            padding: theme.spacing(1),
            ...sx
        },
        ...props,
        children: children
    });
};
const SidebarMenu = ({ sx, children, ...props })=>{
    const theme = material.useTheme();
    return /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        component: "ul",
        sx: {
            width: '100%',
            padding: 0,
            margin: 0,
            display: 'flex',
            flexDirection: 'column',
            gap: theme.spacing(0.5),
            listStyle: 'none',
            ...sx
        },
        ...props,
        children: children
    });
};
const SidebarMenuItem = ({ children, ...props })=>/*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        component: "li",
        ...props,
        children: children
    });
const SidebarContent = ({ sx, children, ...props })=>{
    const theme = material.useTheme();
    return /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        sx: {
            flex: 1,
            display: 'flex',
            flexDirection: 'column',
            gap: theme.spacing(1),
            overflowY: 'auto',
            overflowX: 'hidden',
            '&::-webkit-scrollbar': {
                display: 'none'
            },
            // 隱藏scrollbar firefox
            msOverflowStyle: 'none',
            scrollbarWidth: 'none',
            ...sx
        },
        ...props,
        children: children
    });
};
const SidebarFooter = ({ sx, children, ...props })=>{
    const theme = material.useTheme();
    return /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        sx: {
            display: 'flex',
            alignItems: 'center',
            gap: theme.spacing(1),
            padding: theme.spacing(1),
            ...sx
        },
        ...props,
        children: children
    });
};
const SidebarGroup = ({ sx, children, ...props })=>{
    const theme = material.useTheme();
    return /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        sx: {
            position: 'relative',
            width: '100%',
            display: 'flex',
            flexDirection: 'column',
            padding: theme.spacing(1),
            ...sx
        },
        ...props,
        children: children
    });
};
const SidebarGroupLabel = ({ children, sx, ...props })=>{
    const theme = material.useTheme();
    const { open } = SidebarContext12s.useSidebar();
    return /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        sx: {
            paddingInline: '0.5rem',
            flexShrink: 0,
            display: 'flex',
            alignItems: 'center',
            color: theme.palette.text.secondary,
            fontWeight: 500,
            fontSize: theme.typography.caption.fontSize,
            lineHeight: theme.typography.caption.lineHeight,
            opacity: open ? 1 : 0,
            height: open ? 'auto' : 0,
            transition: theme.transitions.create('height', {
                easing: theme.transitions.easing.sharp,
                duration: theme.transitions.duration.enteringScreen
            }),
            ...sx
        },
        ...props,
        children: children
    });
};
const SidebarGroupContent = ({ sx, children, ...props })=>{
    const theme = material.useTheme();
    return /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        sx: {
            width: '100%',
            fontSize: theme.typography.body2.fontSize,
            lineHeight: theme.typography.body2.lineHeight,
            ...sx
        },
        ...props,
        children: children
    });
};
const SidebarMenuSub = ({ children, sx, ...props })=>{
    const theme = material.useTheme();
    const { open } = SidebarContext12s.useSidebar();
    return /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        component: "ul",
        sx: {
            paddingInline: theme.spacing(1.25),
            marginInline: theme.spacing(1.75),
            display: 'flex',
            flexDirection: 'column',
            gap: theme.spacing(0.5),
            borderLeft: '1px solid',
            borderColor: theme.palette.divider,
            listStyle: 'none',
            opacity: open ? 1 : 0,
            height: open ? 'auto' : 0,
            ...sx
        },
        ...props,
        children: children
    });
};
const SidebarMenuSubItem = ({ children, ...props })=>/*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        component: "li",
        ...props,
        children: children
    });
const SidebarMenuSubButton = ({ children, sx, isActive, ...props })=>{
    const theme = material.useTheme();
    return /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
        sx: {
            display: 'flex',
            alignItems: 'center',
            gap: theme.spacing(1),
            padding: theme.spacing(1),
            cursor: 'pointer',
            backgroundColor: isActive ? theme.palette.action.hover : 'transparent',
            borderRadius: theme.shape.borderRadius,
            '&:hover': {
                backgroundColor: theme.palette.action.hover
            },
            overflow: 'hidden',
            textOverflow: 'ellipsis',
            whiteSpace: 'nowrap',
            ...sx
        },
        ...props,
        children: children
    });
};
const Sidebar = ({ children, sx, ...props })=>{
    const { open, setOpen, openMobile, setOpenMobile, width, isMobile } = SidebarContext12s.useSidebar();
    if (isMobile) {
        return /*#__PURE__*/ jsxRuntime.jsx(SwipeableDrawer, {
            open: openMobile,
            onOpen: ()=>setOpenMobile(true),
            onClose: ()=>setOpenMobile(false),
            variant: "temporary",
            width: width,
            ModalProps: {
                keepMounted: true
            },
            sx: {
                display: {
                    xs: 'block',
                    md: 'none'
                },
                ...sx
            },
            ...props,
            children: children
        });
    }
    return /*#__PURE__*/ jsxRuntime.jsx(SwipeableDrawer, {
        open: open,
        onOpen: ()=>setOpen(true),
        onClose: ()=>setOpen(false),
        variant: "permanent",
        width: width,
        ModalProps: {
            keepMounted: true
        },
        sx: {
            display: {
                xs: 'none',
                md: 'block'
            },
            ...sx
        },
        ...props,
        children: children
    });
};

exports.Sidebar = Sidebar;
exports.SidebarContent = SidebarContent;
exports.SidebarFooter = SidebarFooter;
exports.SidebarGroup = SidebarGroup;
exports.SidebarGroupContent = SidebarGroupContent;
exports.SidebarGroupLabel = SidebarGroupLabel;
exports.SidebarHeader = SidebarHeader;
exports.SidebarMenu = SidebarMenu;
exports.SidebarMenuButton = SidebarMenuButton;
exports.SidebarMenuItem = SidebarMenuItem;
exports.SidebarMenuSub = SidebarMenuSub;
exports.SidebarMenuSubButton = SidebarMenuSubButton;
exports.SidebarMenuSubItem = SidebarMenuSubItem;
