'use client';
var jsxRuntime = require('react/jsx-runtime');
var reactUtils = require('@gateweb/react-utils');
var material = require('@mui/material');
var FileList12s = require('./FileList-12s-DqWQq7uy.js');
var UploadButton12s = require('./UploadButton-12s-D_1rxGmb.js');
var UploadPanel12s = require('./UploadPanel-12s-YvhAzpq1.js');
var useFileUpload12s = require('./useFileUpload-12s-KkOhUfdP.js');

const UploadFile = (props)=>{
    const { acceptMimeTypes = [], maxFiles = 1, files: outerFiles, onAddFile, onRemoveFile, onTypeError, i18n, type = 'drag-and-drop', ...rest } = props;
    const { files, addFile, removeFile } = useFileUpload12s.useFileUpload({
        files: outerFiles,
        onAddFile,
        onRemoveFile
    });
    const handleAddFile = (e)=>{
        if (!e.target.files || e.target.files.length === 0) return;
        const targetFile = e.target.files[0];
        if (!reactUtils.validateFileType(targetFile, acceptMimeTypes)) {
            onTypeError?.();
            return;
        }
        addFile(targetFile);
    };
    const handleDropFile = (e)=>{
        if (!e.dataTransfer.files) return;
        const targetFile = e.dataTransfer.files[0];
        if (!reactUtils.validateFileType(targetFile, acceptMimeTypes)) {
            onTypeError?.();
            return;
        }
        addFile(targetFile);
    };
    if (type === 'drag-and-drop') {
        return /*#__PURE__*/ jsxRuntime.jsxs(material.Stack, {
            spacing: 2,
            ...rest,
            children: [
                /*#__PURE__*/ jsxRuntime.jsx(UploadPanel12s.UploadPanel, {
                    acceptMimeTypes: acceptMimeTypes,
                    handleAddFile: handleAddFile,
                    handleDropFile: handleDropFile,
                    disabled: maxFiles <= files.length,
                    i18n: i18n
                }),
                /*#__PURE__*/ jsxRuntime.jsx(FileList12s.FileList, {
                    files: files,
                    handleDeleteFile: removeFile
                })
            ]
        });
    }
    return /*#__PURE__*/ jsxRuntime.jsxs(material.Stack, {
        spacing: 2,
        ...rest,
        children: [
            /*#__PURE__*/ jsxRuntime.jsx(FileList12s.FileList, {
                files: files,
                handleDeleteFile: removeFile
            }),
            maxFiles > files.length && /*#__PURE__*/ jsxRuntime.jsx(UploadButton12s.UploadButton, {
                acceptMimeTypes: acceptMimeTypes,
                handleAddFile: handleAddFile,
                type: "compact-list"
            })
        ]
    });
};

exports.UploadFile = UploadFile;
