'use client';
import { jsx } from 'react/jsx-runtime';
import { useContext, useMemo, createContext } from 'react';

const BreadcrumbsContext = /*#__PURE__*/ createContext(null);
const BreadcrumbsProvider = ({ extractCurrent = false, currentPosition = 'top', children })=>{
    const contextValue = useMemo(()=>({
            extractCurrent,
            currentPosition
        }), [
        extractCurrent,
        currentPosition
    ]);
    return /*#__PURE__*/ jsx(BreadcrumbsContext.Provider, {
        value: contextValue,
        children: children
    });
};
const useBreadcrumbs = ()=>useContext(BreadcrumbsContext);

export { BreadcrumbsProvider as B, useBreadcrumbs as u };
