'use client';
import { jsxs, jsx } from 'react/jsx-runtime';
import { NavigateBefore, NavigateNext } from '@mui/icons-material';
import { IconButton, Box } from '@mui/material';
import { m as mergeSx, s as serverOnlySx } from './Button-12s-CYbIRpne.mjs';
import { u as useCarousel } from './Carousel-12s-BBzFYCeA.mjs';

const CarouselPrevious = ({ sx, ...props })=>{
    const { orientation, scrollPrev, canScrollPrev } = useCarousel();
    return /*#__PURE__*/ jsxs(IconButton, {
        sx: mergeSx({
            position: 'absolute',
            width: 32,
            height: 32,
            borderRadius: '50%',
            ...orientation === 'horizontal' ? {
                top: '50%',
                left: '-3rem',
                transform: 'translateY(-50%)'
            } : {
                top: '-3rem',
                left: '50%',
                transform: 'translateX(-50%) rotate(90deg)'
            }
        }, sx),
        disabled: !canScrollPrev,
        onClick: scrollPrev,
        ...props,
        children: [
            /*#__PURE__*/ jsx(NavigateBefore, {}),
            /*#__PURE__*/ jsx(Box, {
                component: "span",
                sx: serverOnlySx(),
                children: "Previous slide"
            })
        ]
    });
};
const CarouselNext = ({ sx, ...props })=>{
    const { orientation, scrollNext, canScrollNext } = useCarousel();
    return /*#__PURE__*/ jsxs(IconButton, {
        sx: mergeSx({
            position: 'absolute',
            width: 32,
            height: 32,
            borderRadius: '50%',
            ...orientation === 'horizontal' ? {
                top: '50%',
                right: '-3rem',
                transform: 'translateY(-50%)'
            } : {
                bottom: '-3rem',
                left: '50%',
                transform: 'translateX(-50%) rotate(90deg)'
            }
        }, sx),
        disabled: !canScrollNext,
        onClick: scrollNext,
        ...props,
        children: [
            /*#__PURE__*/ jsx(NavigateNext, {}),
            /*#__PURE__*/ jsx(Box, {
                component: "span",
                sx: serverOnlySx(),
                children: "Next slide"
            })
        ]
    });
};

export { CarouselPrevious as C, CarouselNext as a };
