'use client';
import { jsx } from 'react/jsx-runtime';
import CircularProgress from '@mui/material/CircularProgress';
import MuiIconButton from '@mui/material/IconButton';
import { forwardRef } from 'react';
import { m as mergeSx } from './Button-12s-CYbIRpne.mjs';

/**
 * 表示一個可點擊的圖示按鈕元件，用於觸發相關的業務邏輯。
 *
 * 參考
 *  - [Material-UI IconButton](https://mui.com/material-ui/react-button/#icon-button)
 *  - [Material-UI Icons](https://mui.com/material-ui/material-icons/)
 *
 * @example
 *
 * ```tsx
 * <IconButton>
 *  <DeleteIcon fontSize="inherit" />
 * </IconButton>
 * ```
 */ const IconButton = /*#__PURE__*/ forwardRef((props, ref)=>{
    const { children, sx, loading = false, disabled = false, ...rest } = props;
    return /*#__PURE__*/ jsx(MuiIconButton, {
        ref: ref,
        sx: mergeSx({
            '&.Mui-disabled': {
                pointerEvents: 'inherit',
                cursor: 'not-allowed'
            }
        }, sx),
        disabled: loading || disabled,
        ...rest,
        children: loading ? /*#__PURE__*/ jsx(CircularProgress, {
            color: "inherit",
            size: "1em"
        }) : children
    });
});

export { IconButton as I };
